/*
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
|          Program Name: Wavelib.h                                                                                      |
|                Author: Michael Krmer                                                                                 |
|                        Michael@dk8pp.de               (private)                                                       |
|                  Date: 20-Apr-2005                                                                                    |
|              Language: Open Watcom C 1.6                                                                              |
|               Version: 1.0                                                                                            |
|        Program status: First public release                                                                           |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
|  Purpose: Include file for Wavelib functions                                                                          |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
#ifndef WAVELIB
#include "Mytype.h"

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       Defines                                                                                                         |
+-----------------------------------------------------------------------------------------------------------------------+
*/
#define WAVELIB 1
#define Mode_Read  0            /* file is open for read */
#define Mode_Write 1            /* file is open for write */

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       structs and enums                                                                                               |
+-----------------------------------------------------------------------------------------------------------------------+
*/
typedef struct {
        FILE *cfileptr ;
        _SHORT BitsPerSample ;
        _SHORT Channels ;
        _LONG SamplesPerSecond ;
        _LONG TotalDataChunkLength ;
        _LONG RemainDataChunkLength ;
        _SHORT mode ;
                } WFILE ;

typedef struct {
        const char id[4] ;
        _LONG len ;
        const char wave_id[4] ;
                } RIFF ;

typedef struct {
        const char id[4] ;
        _LONG len ;
                } CHUNK_HDR ;

typedef struct {
        _SHORT wFormatTag ;
        _SHORT wChannels ;
        _LONG  dwSamplesPerSecond ;
        _LONG  dwAvgBytesPerSecond ;
        _SHORT wBlockAlign ;
        _SHORT wBitsPerSample ;
                } FMT_CK ;

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       Function prototypes                                                                                             |
+-----------------------------------------------------------------------------------------------------------------------+
*/
WFILE *wfopen(const char *filename) ;
void *wfgetsample(void *sample, WFILE *wstream) ;
void *wfputsample(void *sample, WFILE *wstream) ;
WFILE *wfcreate(const char *filename, _SHORT bps, _SHORT chs, _LONG sps) ;
void wfclose(WFILE *wstream) ;
int wfeof(WFILE *wstream) ;

#endif
