/*
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
|          Program Name: MakeGRX                                                                                        |
|                Author: Michael Krmer                                                                                 |
|                        Michael@dk8pp.de               (private)                                                       |
|                        Michael.Kraemer@eu.necel.com   (business)                                                      |
|                  Date: 30-Dec-2004                                                                                    |
|              Language: Open Watcom C 1.6                                                                              |
|               Version: 0.1                                                                                            |
|        Program status: still testing                                                                                  |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
|  Purpose: Make GRX File for GetRight                                                                                  |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       Includes                                                                                                        |
+-----------------------------------------------------------------------------------------------------------------------+
*/
#include <stdio.h>
#include <windows.h>
#include <commctrl.h>
#include "WinDef.h"
#include "mytype.h"
#include "MakeGRX.h"
#include "WinLib.h"

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       Defines                                                                                                         |
+-----------------------------------------------------------------------------------------------------------------------+
*/
#define STRINGSIZE 256          /* default size for strings */
#define PARMSIZE 20             /* maximum size of a string or positional command line parameter */
#define MYPARMSIZE 16           /* maximum size of a parameter &a, &b or &c */

#define MY_HKEY HKEY_CURRENT_USER // handle of registry key
#define MY_REG_KEY MY_REG_KEY_ROOT "MakeGRX" // Registry key used by this program
#define PROGRAMNAME "Make GRX File for GetRight"
#define PURPOSE "This program generates a GRX file for GetRight.\r\r\n"\
                "\r\r\n"
#define PROGRAMVERSION 10       /* will be displayed as n.nn */

#define VAR_NUM 3               /* number of variables. Names are always subsequent, i.e. a, b, c, ... */

#define FLAG_CHK_A 0x01         /* Checkbox A */
#define FLAG_CHK_B 0x02         /* Checkbox B */
#define FLAG_CHK_C 0x04         /* Checkbox C */

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       structs and enums                                                                                               |
+-----------------------------------------------------------------------------------------------------------------------+
*/
typedef struct {
        _WORD start ;
        _WORD end ;
        _WORD current ;
        _WORD size ;
        } VARI ;

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       global variables                                                                                                |
+-----------------------------------------------------------------------------------------------------------------------+
*/
HINSTANCE       MyInstance ;
HWND            MainWindow ;
_BYTE strng1[STRINGSIZE] ;
_BYTE strng2[STRINGSIZE] ;
_WORD checkb[] = {CHK_A, CHK_B, CHK_C} ;
_WORD dlg_start[] = {DLG_STARTA, DLG_STARTB, DLG_STARTC} ;
_WORD dlg_end[] = {DLG_ENDA, DLG_ENDB, DLG_ENDC} ;

/*
 Registry definitions
*/
_SWORD registry_x ;             /* left edge of dialog */
_SWORD registry_y ;             /* top edge of dialog */
_SWORD registry_width ;         /* width of dialog */
_SWORD registry_height ;        /* height of dialog */
_SWORD registry_version ;       /* version of program which wrote the registry */
_SWORD registry_flags ;         /* flags */
_BYTE registry_url[STRINGSIZE+1] ; /* URL for registry */
_BYTE registry_dnldest[STRINGSIZE+1] ; /* Download destination for registry */
_BYTE registry_filename[STRINGSIZE+1] ; /* filename for registry */
_BYTE registry_as[MYPARMSIZE+1] ; /* parameter start */
_BYTE registry_ae[MYPARMSIZE+1] ; /* parameter end */
_BYTE registry_bs[MYPARMSIZE+1] ; /* parameter start */
_BYTE registry_be[MYPARMSIZE+1] ; /* parameter end */
_BYTE registry_cs[MYPARMSIZE+1] ; /* parameter start */
_BYTE registry_ce[MYPARMSIZE+1] ; /* parameter end */
REGVALUE regvalue[] = {{"posx", REG_DWORD, &registry_x, 0},
                       {"posy", REG_DWORD, &registry_y, 0},
                       {"width", REG_DWORD, &registry_width, 0},
                       {"height", REG_DWORD, &registry_height, 0},
                       {"version", REG_DWORD, &registry_version, 0},
                       {"flags", REG_DWORD, &registry_flags, 0},
                       {"Astart", REG_SZ, &registry_as, STRINGSIZE},
                       {"Aend", REG_SZ, &registry_ae, STRINGSIZE},
                       {"Bstart", REG_SZ, &registry_bs, STRINGSIZE},
                       {"Bend", REG_SZ, &registry_be, STRINGSIZE},
                       {"Cstart", REG_SZ, &registry_cs, STRINGSIZE},
                       {"Cend", REG_SZ, &registry_ce, STRINGSIZE},
                       {"URL", REG_SZ, &registry_url, STRINGSIZE},
                       {"DownloadDestination", REG_SZ, &registry_dnldest, STRINGSIZE},
                       {"Filename", REG_SZ, &registry_filename, STRINGSIZE}} ;
MYREG myreg = {MY_HKEY, MY_REG_KEY, &regvalue[0], sizeof(regvalue)/sizeof(regvalue[0])} ;

/*
 Command line parameter definitions
*/
_BOOL disablereg = FALSE ;      /* disable use of the registry */
_BYTE posparm1[PARMSIZE+1] ;    /* positional parameter 1 */
_BYTE posparm2[PARMSIZE+1] ;    /* positional parameter 2 */

CLO clo[] = {{"rc", PARM_SIMPLE, NULL, 0, FALSE, "clear registry entries for this program"},
             {"rd", PARM_SIMPLE, NULL, 0, FALSE, "disable use of the registry for this program"},
             {"pp", PARM_INT, NULL, 0, FALSE, "set process priority for dialog\r\r\n"
                                       "       (0:idle, 1:normal, 2:high, 3:realtime)"},
             {"pt", PARM_INT, NULL, 0, FALSE, "set priority for processing thread\r\r\n"
                                       "       (0:idle, 1:lowest, 2:below normal, 3:normal,\r\r\n"
                                "        4:above normal, 5:highest, 6:time critical)"} } ;
_WORD clo_size = sizeof(clo)/sizeof(clo[0]) ;

/* These are indexes into the CLO table above. Keep them in sync */
#define PARM_RC 0
#define PARM_RD 1
#define PARM_PP 2
#define PARM_PT 3

_BYTE errorparm[MAXPARMLENGTH] ;

/*
 Dialog coordinates definitions
*/
COORDS coordinates[] = {{0, 0, 0, 0, 0, 0},  /* first entry is reserved for main dialog */
                        {DLG_STATUS, 0, 0, 0, 0, RESIZE_X|RESIZE_Y|MOVE_Y},
                        {DLG_OUTFILENAME, 0, 0, 0, 0, RESIZE_X},
                        {DLG_URL, 0, 0, 0, 0, RESIZE_X},
                        {DLG_DEST, 0, 0, 0, 0, RESIZE_X},
                        {BUT_INFO, 0, 0, 0, 0, MOVE_Y},
                        {BUT_START, 0, 0, 0, 0, MOVE_X|MOVE_Y},
                        {BUT_EXIT, 0, 0, 0, 0, MOVE_X|MOVE_Y}
                       } ;
COORDS *sorted_coord[sizeof(coordinates)/sizeof(coordinates[0])-1] ;
WORD coord_size = sizeof(coordinates)/sizeof(coordinates[0]) ;
_BOOL validreg = FALSE ;        /* valid data from registry retrieved */
_BOOL abort_thread = FALSE ; /* set TRUE to abort the thread */
_BOOL thread_suspended = FALSE ;
_BYTE purpose[] = PURPOSE ;

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       Function prototypes                                                                                             |
+-----------------------------------------------------------------------------------------------------------------------+
*/
BOOL CALLBACK MakeGRX(HWND window_handle, unsigned msg, WPARAM wparam, LPARAM lparam) ;
void display_info(_BYTE *msg) ;
void format(BYTE *dest, BYTE *src, VARI *vari) ;
void make_current(BYTE *dest, VARI *vari) ;
DWORD WINAPI DoOperation(LPVOID lpParam) ;
void EnableControls(_BOOL enable) ;

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       WinMain                                                                                                         |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| MAIN program.                                                                                                         |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
int WINAPI WinMain(HINSTANCE this_inst, HINSTANCE prev_inst, LPSTR cmdline, int cmdshow)
{
_LONG static volatile rv ;
_BOOL startup ;
   startup = TRUE ;
   errorparm[0] = '\0' ;
   getparms(cmdline, errorparm) ;
   if (clo[PARM_RC].found) clear_registry(&myreg) ;
   disablereg = clo[PARM_RD].found ;
   if (startup)
   { /* start windowed version */
      if (clo[PARM_PP].found) set_process_prio(clo[PARM_PP].value) ;
      MyInstance = this_inst ;
      InitCommonControls() ;
      rv = DialogBox(this_inst, "DLG_MAKEGRX", 0, (DLGPROC)MakeGRX) ;
   }
   return(0);
}

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       MakeGRX                                                                                                         |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| Processes messages for the DLG_MAKEGRX dialog                                                                         |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
BOOL CALLBACK MakeGRX(HWND window_handle, unsigned msg, WPARAM wparam, LPARAM lparam)
{
OPENFILENAME outfilestruct ;
_BYTE static outfilename_no_path[256] ;
_BYTE static def_out_ext[] = "GRX files\0*.grx\0All files\0*.*\0" ;
_BYTE static default_extension[] = "grx" ;
BOOL retcd ;
RECT static rect ;
HFONT hFont ;
DWORD static dwThreadId, dwThrdParam = 1 ;
HANDLE static hThread ;
_BYTE *out_msg ;

   retcd = 0 ; /* return 0 if we don't process the message */
   validreg = FALSE ;
   switch(msg)
   {
   case WM_INITDIALOG:
      retcd = 1 ;
      MainWindow = window_handle ;
// Make sure to define the below mentioned icon!
      SendMessage(MainWindow, WM_SETICON, ICON_BIG, (LPARAM) LoadIcon(MyInstance, "MyWinIcon")) ;
//    ShowError(DLG_STATUS) ; /* display last error message */

// save original coordinates of dialog
      SaveCoordinates() ;

// Select font for controls (sample code)
      hFont = CreateFont(
          15,                  // logical height of font
          0,                   // logical average character width
          0,                   // angle of escapement
          0,                   // base-line orientation angle
          FW_NORMAL,           // font weight
          FALSE,               // italic attribute flag
          FALSE,               // underline attribute flag
          FALSE,               // strikeout attribute flag
          ANSI_CHARSET,        // character set identifier
          OUT_DEFAULT_PRECIS,  // output precision
          CLIP_DEFAULT_PRECIS, // clipping precision
          DEFAULT_QUALITY,     // output quality
          DEFAULT_PITCH,       // pitch and family
          "Courier New"        // pointer to typeface name string
      ) ;

      SendMessage(GetDlgItem(MainWindow, DLG_URL), WM_SETFONT, (WPARAM) hFont, MAKELPARAM(FALSE, 0));
      SendMessage(GetDlgItem(MainWindow, DLG_DEST), WM_SETFONT, (WPARAM) hFont, MAKELPARAM(FALSE, 0));
      SendMessage(GetDlgItem(MainWindow, DLG_OUTFILENAME), WM_SETFONT, (WPARAM) hFont, MAKELPARAM(FALSE, 0));

      validreg = get_registry(&myreg) ; // get registry content

      if (validreg)
      {
         MoveWindow(
         MainWindow,            // handle of window
         registry_x,            // horizontal position
         registry_y,            // vertical position
         registry_width,        // width
         registry_height,       // height
         TRUE);                 // repaint flag
         SetDlgItemText(MainWindow, DLG_URL, registry_url) ;
         SetDlgItemText(MainWindow, DLG_DEST, registry_dnldest) ;
         SetDlgItemText(MainWindow, DLG_OUTFILENAME, registry_filename) ;
         SetDlgItemText(MainWindow, DLG_STARTA, registry_as) ;
         SetDlgItemText(MainWindow, DLG_STARTB, registry_bs) ;
         SetDlgItemText(MainWindow, DLG_STARTC, registry_cs) ;
         SetDlgItemText(MainWindow, DLG_ENDA, registry_ae) ;
         SetDlgItemText(MainWindow, DLG_ENDB, registry_be) ;
         SetDlgItemText(MainWindow, DLG_ENDC, registry_ce) ;
         CheckDlgButton(MainWindow, CHK_A, ((registry_flags & FLAG_CHK_A) != 0) ? BST_CHECKED : BST_UNCHECKED) ;
         CheckDlgButton(MainWindow, CHK_B, ((registry_flags & FLAG_CHK_B) != 0) ? BST_CHECKED : BST_UNCHECKED) ;
         CheckDlgButton(MainWindow, CHK_C, ((registry_flags & FLAG_CHK_C) != 0) ? BST_CHECKED : BST_UNCHECKED) ;
      }

      /* display any illegal parameter */
      if (strlen(errorparm) != 0)
      {
         LoadString(MyInstance, STR_INVALIDPARM, strng1, STRINGSIZE);
         sprintf(strng2, strng1, errorparm) ;
         SetDlgItemText(MainWindow, DLG_STATUS, strng2) ;
      }
#ifdef SUSPENDBUTTON
      EnableWindow(GetDlgItem(MainWindow, BUT_SUSPEND), FALSE) ;
#endif
   break ;

   case WM_USER:
      retcd = 1 ;
      switch(LOWORD(wparam))
      {
      case USER_THREAD_ENDED:
      // output the results
         if (abort_thread)
         {
            LoadString(MyInstance, STR_ABORTED, strng1, STRINGSIZE) ;
            abort_thread = FALSE ;
         }
         else
            LoadString(MyInstance, STR_NORMAL_END, strng1, STRINGSIZE) ;
         out_msg = strng1 ;
/* Thread may have assembled a message. If so, use it */
         if (lparam != NULL) out_msg = (_BYTE *) lparam ;
         SetDlgItemText(MainWindow, DLG_STATUS, out_msg) ;
         CloseHandle(hThread) ;
         hThread = NULL ;
         EnableControls(TRUE) ;
#ifdef SUSPENDBUTTON
         EnableWindow(GetDlgItem(MainWindow, BUT_SUSPEND), FALSE) ;
#endif
      break ;
      }
   break ;

   case WM_COMMAND:
      retcd = 1 ;
      switch(LOWORD(wparam))
      {
      case BUT_OUTPUT:
         outfilestruct.lStructSize = sizeof(OPENFILENAME) ;
         outfilestruct.hwndOwner = MainWindow ;
         outfilestruct.hInstance = 0 ;
         outfilestruct.lpstrFilter = def_out_ext ;
         outfilestruct.lpstrCustomFilter = NULL ;
         outfilestruct.nMaxCustFilter = 0 ;
         outfilestruct.nFilterIndex = 1 ;
         outfilestruct.lpstrFile = registry_filename ;
         outfilestruct.nMaxFile = sizeof(registry_filename) ;
         outfilestruct.lpstrFileTitle = outfilename_no_path ;
         outfilestruct.nMaxFileTitle = sizeof(outfilename_no_path) ;
         outfilestruct.lpstrInitialDir = NULL ;
         outfilestruct.lpstrTitle = "GRX output file" ;
         outfilestruct.Flags = OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT ;
         outfilestruct.nFileOffset = 0 ;
         outfilestruct.nFileExtension = 0 ;
         outfilestruct.lpstrDefExt = default_extension ;
         outfilestruct.lCustData = NULL ;
         outfilestruct.lpfnHook = NULL ;
         outfilestruct.lpTemplateName = NULL ;
         if (GetSaveFileName(&outfilestruct) != 0)
         {
            SetDlgItemText(MainWindow, DLG_OUTFILENAME, outfilestruct.lpstrFile) ;
         }
      break ;

      case BUT_INFO:
         sprintf(strng1, "Version %u.%2.2u", PROGRAMVERSION/100, PROGRAMVERSION%100) ;
         PrintProgramInfo(DLG_HELPLIST, PROGRAMNAME, strng1, __DATE__, __TIME__) ;
      break ;

      case IDOK:
      case BUT_START:
         /* The start button becomes abort, if the thread is suspended */
         if (thread_suspended)
         {
            abort_thread = TRUE ;
#ifdef SUSPENDBUTTON
            SendMessage(MainWindow, WM_COMMAND, BUT_SUSPEND, 0) ;
#endif
         }
         else
         {
/* Operation is done in a thread. Start it. */
            hThread = CreateThread(
                NULL,                        // no security attributes
                0,                           // use default stack size
                DoOperation,                 // thread function
                &dwThrdParam,                // argument to thread function
                0,                           // use default creation flags
                &dwThreadId);                // returns the thread identifier

        // Check the return value for success.
            if (hThread == NULL)
               LoadString(MyInstance, STR_THREADSTARTERROR, strng1, STRINGSIZE) ;
            else
            { /* Thread started properly */
               LoadString(MyInstance, STR_WORKING, strng1, STRINGSIZE) ;
               EnableControls(FALSE) ;
               thread_suspended = FALSE ;
#ifdef SUSPENDBUTTON
               EnableWindow(GetDlgItem(MainWindow, BUT_SUSPEND), TRUE) ;
#endif
               if (clo[PARM_PT].found) set_thread_prio(hThread, clo[PARM_PT].value) ;
            }
            SetDlgItemText(MainWindow, DLG_STATUS, strng1) ;
         }
      break ;

      case IDABORT:
      case IDCANCEL:
      case BUT_EXIT:
         GetWindowRect(MainWindow, &rect) ; /* get current dialog coordinates */
         registry_x = rect.left ;
         registry_y = rect.top ;
         registry_width = rect.right - rect.left ;
         registry_height = rect.bottom - rect.top ;
         if (registry_x < 0) registry_x = 0 ;
         if (registry_y < 0) registry_y = 0 ;
         GetDlgItemText(MainWindow, DLG_STARTA, registry_as, sizeof(registry_as)) ;
         GetDlgItemText(MainWindow, DLG_STARTB, registry_bs, sizeof(registry_bs)) ;
         GetDlgItemText(MainWindow, DLG_STARTC, registry_cs, sizeof(registry_cs)) ;
         GetDlgItemText(MainWindow, DLG_ENDA, registry_ae, sizeof(registry_ae)) ;
         GetDlgItemText(MainWindow, DLG_ENDB, registry_be, sizeof(registry_be)) ;
         GetDlgItemText(MainWindow, DLG_ENDC, registry_ce, sizeof(registry_ce)) ;
         registry_flags = ((IsDlgButtonChecked(MainWindow, CHK_A) == BST_UNCHECKED) ? 0 : FLAG_CHK_A)
                        + ((IsDlgButtonChecked(MainWindow, CHK_B) == BST_UNCHECKED) ? 0 : FLAG_CHK_B)
                        + ((IsDlgButtonChecked(MainWindow, CHK_C) == BST_UNCHECKED) ? 0 : FLAG_CHK_C) ;
         registry_version = PROGRAMVERSION ;    /* version of program which wrote the registry */
         put_registry(&myreg) ;                 /* store the dialog properties in registry */
         EndDialog(MainWindow, TRUE);           /* exits the dialog box */
      break ;

      default:
         retcd = 0 ; /* we have not processed this command, so return zero */
      break ;
      }
   break ;

   default:
      retcd = WinLibMessage(msg, wparam, lparam) ; /* WinLib processes some messages */
   break ;
   }

   return(retcd);
} /* MakeGRX */

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       void EnableControls(_BOOL enable)                                                                               |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| Enable or disable some critical controls during execution of thread.                                                  |
| Control gets enabled if enable is TRUE, otherwise it gets disabled.                                                   |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
void EnableControls(_BOOL enable)
{
   EnableWindow(GetDlgItem(MainWindow, BUT_START), enable) ;
}

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       format                                                                                                          |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| Format the target string. Replace variables by values.                                                                |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
void format(BYTE *dest, BYTE *src, VARI *vari)
{
_WORD i, j, k ;
BYTE static va[16] ;
BYTE static vb[16] ;
BYTE static vc[16] ;
   make_current(va, &vari[0]) ;
   make_current(vb, &vari[1]) ;
   make_current(vc, &vari[2]) ;
   i = 0 ; j = 0 ; k = 0 ;
   while (src[i] != '\0')
   {
      if (src[i] == '&')
      {
         if (src[i+1] == '&')
         { /* write & to dest */
            dest[j] = '&' ;
            j++ ;
            i += 2 ;
         }
         else
         { /* variable */
            i++ ;
            if ((src[i] == 'a') | (src[i] == 'A'))
            {
                for (k=0; k<vari[0].size; k++) dest[j++] = va[k] ;
            }
            if ((src[i] == 'b') | (src[i] == 'B'))
            {
                for (k=0; k<vari[1].size; k++) dest[j++] = vb[k] ;
            }
            if ((src[i] == 'c') | (src[i] == 'C'))
            {
                for (k=0; k<vari[2].size; k++) dest[j++] = vc[k] ;
            }
            i++ ;
         }
      }
      else
      { /* copy character */
         dest[j++] = src[i++] ;
      }
   }
   dest[j] = '\0' ;
}

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       make_current                                                                                                    |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| Decode and return current value of variable in the correct length.                                                    |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
void make_current(BYTE *dest, VARI *vari)
{
BYTE fmt[16] ;
   sprintf(fmt,"%%%u.%uu", vari->size, vari->size) ;
   sprintf(dest, fmt, vari->current) ;
}

/*
+-----------------------------------------------------------------------------------------------------------------------+
|       DoOperation(LPVOID lpParam)                                                                                     |
+-----------------------------------------------------------------------------------------------------------------------+
|                                                                                                                       |
| This thread does whatever this program is supposed to do.                                                             |
|                                                                                                                       |
+-----------------------------------------------------------------------------------------------------------------------+
*/
DWORD WINAPI DoOperation(LPVOID lpParam)
{
_WORD i ;
_BOOL error, size_error ;
FILE *outfile = NULL ;
_WORD size ;
VARI static vari[VAR_NUM] ;
_BYTE static strng_thread1[STRINGSIZE] ;
_BYTE *retcd ;
// get dialog contents
   GetDlgItemText(MainWindow, DLG_OUTFILENAME, registry_filename, sizeof(registry_filename)) ;
   GetDlgItemText(MainWindow, DLG_DEST, registry_dnldest, sizeof(registry_dnldest)) ;
   GetDlgItemText(MainWindow, DLG_URL, registry_url, sizeof(registry_url)) ;

   error = FALSE ;
   size_error = FALSE ;
   retcd = NULL ; /* NULL means no error */

   for (i=0; i<VAR_NUM; i++)
   {
      vari[i].start = 0 ;
      vari[i].end = 0 ;
      vari[i].size = 0 ;
      if (IsDlgButtonChecked(MainWindow, checkb[i]))
      {
         GetDlgItemText(MainWindow, dlg_start[i], strng_thread1, sizeof(strng_thread1)) ;
         vari[i].size = strlen(strng_thread1) ;
         size = sscanf(strng_thread1, "%u", &(vari[i].start)) ;
         if (size != 1) error = TRUE ;
         GetDlgItemText(MainWindow, dlg_end[i], strng_thread1, sizeof(strng_thread1)) ;
         if (strlen(strng_thread1) != vari[i].size) size_error = TRUE ;
         size = sscanf(strng_thread1, "%u", &(vari[i].end)) ;
         if (size != 1) error = TRUE ;
      }
      if (vari[i].start > vari[i].end) error = TRUE ;
   }

/* Error display */
   if (error)
   {
      LoadString(MyInstance, STR_INVALIDNUMBER, strng_thread1, sizeof(strng_thread1));
      retcd = strng_thread1 ;
   }

   if (size_error)
   {
      LoadString(MyInstance, STR_SIZEMISMATCH, strng_thread1, sizeof(strng_thread1));
      retcd = strng_thread1 ;
   }

   if ((!error) && (!size_error))
   {
      outfile = fopen(registry_filename, "wt") ;
      if (outfile == NULL)
      {
         error = TRUE ;
//         ShowError(DLG_STATUS) ;
         FormatMessage(
             FORMAT_MESSAGE_FROM_SYSTEM,
             NULL,
             GetLastError(),
             MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT), // Default language
             strng_thread1,
             STRINGSIZE-1,
             NULL) ;
         retcd = strng_thread1 ;
      }
      else
      {
         for (vari[0].current = vari[0].start; vari[0].current <= vari[0].end; vari[0].current++)
         {
            for (vari[1].current = vari[1].start; vari[1].current <= vari[1].end; vari[1].current++)
            {
               for (vari[2].current = vari[2].start; vari[2].current <= vari[2].end; vari[2].current++)
               {
                  format(strng_thread1, registry_url, vari) ;
                  fprintf(outfile, "URL: %s\n", strng_thread1) ;
                  format(strng_thread1, registry_dnldest, vari) ;
                  fprintf(outfile, "File: %s\n", strng_thread1) ;
               }
            }
         }
/* Display success */
         LoadString(MyInstance, STR_SUCCESS, strng_thread1, STRINGSIZE);
         retcd = strng_thread1 ;
      }
      if (outfile != NULL) {fclose(outfile) ; outfile = NULL ; }
   }

// Notify main window that the thread is finished
   SendMessage(MainWindow, WM_USER, USER_THREAD_ENDED, (LPARAM) retcd) ;

   return 0;
}



